// FastDraw.h: CFastDraw NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FASTDRAW_H__899B2B0E_463B_41EE_BADC_9910578867E9__INCLUDED_)
#define AFX_FASTDRAW_H__899B2B0E_463B_41EE_BADC_9910578867E9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CFastDraw  
{
public:
	void Init(CDC* pDC, CRect* pRect);
	CFastDraw(CDC* pDC, CRect* pRect);
	CFastDraw();
	virtual ~CFastDraw();

// obt@֒ڂ̕`
// v : bmp ̕16̔{A24bit J[摜
void SetPixel( int x, int y, COLORREF c)
{
	if(m_bmp.bmBits == NULL) return;
	if(x<0 || y<0 || x>=m_bmp.bmWidth || y>=m_bmp.bmHeight) return;
	LPBYTE p = (LPBYTE)(m_bmp.bmBits);
	unsigned int addr = (y)*m_bmp.bmWidthBytes + x*m_bmp.bmBitsPixel/8;
	p[addr] = GetBValue(c);
	p[addr+1] = GetGValue(c);
	p[addr+2] = GetRValue(c);
}
void GetPixelRGB( int x, int y, int* r, int* g, int* b)
{
	if(x<0 || y<0 || x>=m_bmp.bmWidth || y>=m_bmp.bmHeight) return;
	if(m_bmp.bmBits == NULL) return;
	LPBYTE p = (LPBYTE)(m_bmp.bmBits);
	unsigned int addr = (y)*m_bmp.bmWidthBytes + x*m_bmp.bmBitsPixel/8;

	*b = p[addr];
	*g = p[addr+1];
	*r = p[addr+2];
}
void DrawLine( int x1, int y1, int x2, int y2, COLORREF c){
	int x, y;
	if(x1==x2) {
		if(y1>y2) {
			swap(y1, y2);
		}
		for(y=y1; y<=y2; y++){
			SetPixel(x1, y, c);
		}
		return ;
	}
	if(x1>x2) {
		swap(x1, x2);
		swap(y1, y2);
	}
	double dx = 1.0/(double)(x2-x1);
	for(x=0; x<=x2-x1; x++){
		double d = x*dx;
		for(y=y1+(y2-y1)*d; y<=y1+(y2-y1)*(d+dx); y++){
			SetPixel(x1+x, y, c);
		}
		for(y=y1+(y2-y1)*(d+dx); y<y1+(y2-y1)*(d); y++){
			SetPixel(x1+x, y, c);
		}
	}
}
void DrawRect( int x1, int y1, int x2, int y2, COLORREF border, COLORREF inner, int fill){
	DrawLine( x1, y1, x2, y1, border);
	DrawLine( x2, y1, x2, y2, border);
	DrawLine( x1, y2, x2, y2, border);
	DrawLine( x1, y1, x1, y2, border);
	if(fill){
		int x, y;
		for(y=y1+1; y<=y2-1; y++){
			for(x=x1+1; x<=x2-1; x++){
				SetPixel( x, y, inner);
			}
		}
	}
}
private:
	CDC m_dc;
	CDC* m_pDC;
	BITMAP m_bmp;
	CBitmap m_dummyBMP;
	BYTE* m_bitmapData;
	CRect m_rect;
	int m_initCalled;
private:
	// FastDraw
	void FastDraw_End(BYTE* bitmapData, CDC* pDC, BITMAP* pbmp){
		int bitmapSize = pbmp->bmHeight*pbmp->bmWidthBytes;
		pDC->GetCurrentBitmap()->SetBitmapBits(bitmapSize, pbmp->bmBits);
		delete[] bitmapData;
	}
	BYTE* FastDraw_Start(CDC* pDC, BITMAP* pbmp){
		// `obt@擾
		pDC->GetCurrentBitmap()->GetBitmap(pbmp);
		int bitmapSize = pbmp->bmHeight*pbmp->bmWidthBytes;
		BYTE* bitmapData = new BYTE[bitmapSize];

		pbmp->bmBits = bitmapData;
		if(pDC->GetCurrentBitmap()->GetBitmapBits(bitmapSize, pbmp->bmBits) == 0){
			return NULL;
		}
		return bitmapData;
	}
	void LeftShift(){
		if(m_bmp.bmBits == NULL) return;
		LPBYTE p = (LPBYTE)(m_bmp.bmBits);
		int y;
		for(y=0; y<m_bmp.bmHeight; y++){
			unsigned int dest = (y)*m_bmp.bmWidthBytes;
			memcpy(p+dest, p+dest+m_bmp.bmBitsPixel/8, (m_bmp.bmWidth-1)*m_bmp.bmBitsPixel/8);
		}
	}


};

#endif // !defined(AFX_FASTDRAW_H__899B2B0E_463B_41EE_BADC_9910578867E9__INCLUDED_)
